
#include <MsTimer2.h>
#include <EEPROM.h>
#include <Encoder.h>
#include <TM1637Display.h>

#define Fuse              2                                 // Вход прерывания. Датчик Фазы
#define AC_LOAD           6                                 // Вывод для управления симистором
int  Dimming[]          = {127, 127};                       // Уровень затемнения (0-128) 0 = вкл, 128 = выкл
int  dimtime            = 127;
/*-----------------------------------------------------------------------------------------------------*/
Encoder myEnc(3, 5);
#define SB_Enc            4
long oldPosition        = 0;
#define KEY_Start         12
byte SB_Touch           = 0;
/*-----------------------------------------------------------------------------------------------------*/
#define CLK     11
#define DIO     10

TM1637Display TM1637(CLK, DIO);                                               // Set up the 4-Digit Display.

//  uint8_t data[]      = {0xFF, 0xFF, 0xFF, 0xFF};
uint8_t data[]        = {0, 0, 0, 0};
byte Digit[]          = {0, 0, 0, 0, 0};

int  Digit_0[]        = {0xBF,0x86,0xDB,0xCF,0xE6,0xED,0xAD,0x87,0xFF,0xEF};
int  Digit_1[]        = {0x3F,0x06,0x5B,0x4F,0x66,0x6D,0x7D,0x07,0x7F,0x6F};
int  Digit_2[]        = {0x00,0x06,0x5B,0x4F,0x66,0x6D,0x7D,0x07,0x7F,0x6F};
int  Digit_3[]        = {0x00,0x40,0xCF,0xCF,0xF3,0xB9,0xEE,0xEE,0xBF,0x00};
/*-----------------------------------------------------------------------------------------------------*/
byte PWM[]                = {0};
byte Fuse_Pause_ON        = 5;
int  Indic;
byte Flag_OFF             = 0;
byte Flag_V               = 1;

byte Start_ON             = 0;
byte digitBuffer[3];

byte Impuls               = 1;
byte Select               = 1;
byte Second_Impuls        = 0;
int  Sec[]                = {0, 0, 0, 0};
byte Write                = 0;

#define Dig_ON    Digit[2] = 1;
#define Dig_OFF   Digit[2] = 0;
#define Led_ON    Dig_ON  Display(); for (byte i = 0; i <= 3; i++) TM1637.setSegments(data + i, 1, i);
#define Led_OFF   Dig_OFF Display(); for (byte i = 0; i <= 3; i++) TM1637.setSegments(data + i, 1, i);
#define Zero_S    if (Fuse_Pause_ON == 0) Fuse_Pause_ON = 5; if (Impuls == 0) Impuls = 1; if (PWM[0] == 0) PWM[0] = 20; \
                  if (Fuse_Pause_ON >= 6) Fuse_Pause_ON = 5; if (Impuls >= 3) Impuls = 1; if (PWM[0] >= 100) PWM[0] = 20;
/*=======================================================================================================
                                  Преобразования слова в BCD значениe
=======================================================================================================*/
int   High               = 0;                            // Переменная для хранения старшей тетрады
int   Low                = 0;                            // Переменная для хранения младшей тетрады
int   Num[]              = {0, 0, 0, 0, 0};
#define Zero for (byte i = 1; i <= 4; i++) Num[i] = 0; Low = Num[0]; High = 0; Num[4] = Low;
#define Zero_H Low = High; High = 0;
#define WORD_to_BCD  Zero   while (Num[4] >= 10) NUM(4); Zero_H while (Num[3] >= 10) NUM(3); \
                     Zero_H while (Num[2] >= 10) NUM(2); Zero_H while (Num[1] >= 10) NUM(1); Num[0] = 0;
void NUM(byte Numb) {High++; Low -= 10; Num[Numb] = Low; Num[Numb - 1] = High;}
void Convert(int Temp) {Num[0] = Temp; WORD_to_BCD for (byte i = 1; i <= 4; i++) Digit[i] = Num[i]; Display();}
/*=======================================================================================================
                                              Чтение EEPROM
=======================================================================================================*/
void EEPROM_Read()
{
  for (int i = 0; i <= 2; i++)
  {
    digitBuffer[i] = EEPROM.read(i);                // считываем значение по текущему адресу EEPROM
  }
  Serial.println(" << READ >> "); Serial.println("  ");
  Fuse_Pause_ON = digitBuffer[0];
  Impuls        = digitBuffer[1];
  PWM[0]        = digitBuffer[2];
}
/*=======================================================================================================
                                              Запись EEPROM
=======================================================================================================*/
void EEPROM_Write()
{
  for (int i = 0; i <= 2; i++)
  {
    EEPROM.write(i, digitBuffer[i]);
  }
  Serial.println(" << WRITE >> ");
}
/*=======================================================================================================
                                    Функция включения симистора по прерыванию                               
=======================================================================================================*/
void Front_Up()                                       // Прерывание по изменению уровня с низкого на высокий
{
  delay(Fuse_Pause_ON);                               // Пауза для включения симистора на пике волны
  digitalWrite(AC_LOAD, HIGH);                        // Включить симистор
  detachInterrupt(0);     
}
/*=======================================================================================================
                                              Инициализация
=======================================================================================================*/
void setup() 
{
  Serial.begin(115200);

  TM1637.setBrightness(0x0F);                           // Устанавливаем яркость дисплея
  float Versiya = 2.2; Convert(Versiya * 100); 
  for (byte i = 0; i <= 3; i++) TM1637.setSegments(data + i, 1, i);
  pinMode(Fuse, INPUT_PULLUP);
  pinMode(AC_LOAD, OUTPUT);                           // Вывод назначаем как выход
  digitalWrite(AC_LOAD, LOW);
  delay(1000);
  pinMode(SB_Enc, INPUT_PULLUP);
  pinMode(KEY_Start, INPUT_PULLUP);
    
  Serial.println(" ");
  Serial.println(" << WELDING >>");
  
//  EEPROM_Write();
  EEPROM_Read(); Zero_S
  
  MsTimer2::set(1, Timing_ISR);                         // Задаем период прерывания по таймеру 1 мс
  MsTimer2::start();                                    // Разрешаем прерывание по таймеру
}
/*=======================================================================================================
                                              Главный цикл
=======================================================================================================*/
void loop() 
{
  Display();
  Encode();
  Indic = (Impuls * 1000) + PWM[0];
/*-----------------------------------------------------------------------------------------------------*/ 
  if (Select == 0) {Convert(Fuse_Pause_ON); TM1637.showNumberDec(Fuse_Pause_ON);}
  if (Select == 1) {Convert(Indic); for (byte i = 0; i <= 3; i++) TM1637.setSegments(data + i, 1, i);}
  if (Select == 2) {Convert(PWM[0]); TM1637.showNumberDec(PWM[0]);}
  if (Select == 3) {Convert(Impuls); TM1637.showNumberDec(Impuls);}
/*-----------------------------------------------------------------------------------------------------*/ 
}
/*=======================================================================================================
                                              Encoder
=======================================================================================================*/
void Encode()
{
  long newPosition = myEnc.read() / 4;
  if (oldPosition != newPosition) 
  {
    if (oldPosition < newPosition)
    {
      if (Select == 0) {if (Fuse_Pause_ON <= 4) Fuse_Pause_ON++; digitBuffer[0] = Fuse_Pause_ON;}
      if (Select == 2) {if (PWM[0] <= 98) PWM[0]++; digitBuffer[2] = PWM[0];}
      if (Select == 3) {if (Impuls == 1) Impuls += 1; digitBuffer[1] = Impuls;}
    }
    if (oldPosition > newPosition)
    {
      if (Select == 0) {if (Fuse_Pause_ON >= 2) Fuse_Pause_ON--; digitBuffer[0] = Fuse_Pause_ON;}
      if (Select == 2) {if (PWM[0] >= 6) PWM[0]--; digitBuffer[2] = PWM[0];}
      if (Select == 3) {if (Impuls == 2) Impuls -= 1; digitBuffer[1] = Impuls;}
    }
    oldPosition = newPosition;
  }
/*-----------------------------------------------------------------------------------------------------*/
    if (digitalRead(SB_Enc) == 0)
    {
      switch (Select)
      {
        case 0: Select = 1; break;
        case 1: Select = 2; break;
        case 2: Select = 3; break;
        case 3: Select = 0; break;
      }
      SB_Touch = 0; Sec[2] = 0;
      while (SB_Touch == 0)                                 // Ждем пока не отпустят кнопку
      {
        if (digitalRead(SB_Enc) == 0) SB_Touch = 0; else SB_Touch = 1;
        if (Sec[2] >= 500)
        {
          Sec[1] = 0; Sec[2] = 0;
          Write = 1; EEPROM_Write(); EEPROM_Read();
          Led_ON  
          Select = 1; SB_Touch = 1;
        }
        delay(10);        
      }
    }
}
/*=======================================================================================================
                                              Динамическая индикация
=======================================================================================================*/
void Display()
{
  if (Flag_V == 1)
  {
    for (byte i = 0; i <= 9; i++)                                 // Загружаем значения цифр от 0 до 9
    {
      if (Digit[1] == i) data[0] = Digit_2[i];
      if (Digit[2] == i) data[1] = Digit_0[i];
      if (Digit[3] == i) data[2] = Digit_1[i];
      if (Digit[4] == i) data[3] = Digit_2[i];
    }
    Flag_V = 0;
  }
  else
  {
    if (Write == 0)
    {
      if (Start_ON != 0)
      {
        for (byte i = 0; i <= 9; i++)                                 // Загружаем значения цифр от 0 до 9
        {
          if (Digit[1] == i) data[0] = Digit_2[i];
          if (Digit[2] == i) data[1] = Digit_3[i];
          if (Digit[3] == i) data[2] = Digit_2[i];
          if (Digit[4] == i) data[3] = Digit_1[i];
        }
      }
      else
      {
        for (byte i = 0; i <= 9; i++)                                 // Загружаем значения цифр от 0 до 9
        {
          if (Digit[1] == i) data[0] = Digit_2[i];
          if (Digit[2] == i) data[1] = Digit_2[i];
          if (Digit[3] == i) data[2] = Digit_1[i];
          if (Digit[4] == i) data[3] = Digit_1[i];
        }
      }
    }
    else
    {
      for (byte i = 0; i <= 9; i++)                                 // Загружаем значения цифр от 0 до 9
      {
        if (Digit[1] == i) data[0] = Digit_3[i];
        if (Digit[2] == i) data[1] = Digit_3[i];
        if (Digit[3] == i) data[2] = Digit_3[i];
        if (Digit[4] == i) data[3] = Digit_3[i];
      }
      Write = 0;
    }
  }
}
/*=====================================================================================================*/
